package ctalz.cnstr;

import java.util.*;
import ctalz.util.*;

public class ConstExpr extends Expr
{
	private int value;
	private static final ConstExpr[] cache = new ConstExpr[256];
	
	static {
		for (int i = -128; i <= 127; i++) {
			cache[i + 128] = new ConstExpr(i);
		}
	}
	
	private ConstExpr(int val)
	{
		value = val;
	}
	public static ConstExpr valueOf(int val)
	{
		if (-128 <= val && val <= 127)
			return cache[val + 128];
		return new ConstExpr(val);
	}
	
	public int value()
	{
		return value;
	}
	
	protected Collection<VarExpr> collectFreeVariables(Collection<VarExpr> set)
	{
		return set;
	}
	
	public  Expr substitute(Map<VarExpr, Expr> map)
	{
		return this;
	}
	
	protected void appendForUser(StringBuilder out, int outerPriority, boolean longFormat)
	{
		if (value < 0 && outerPriority > 0)
			out.append('(').append(value).append(')');
		else
			out.append(value);
	}
	protected void appendForSolver(StringBuilder out)
	{
		out.append(value);
	}
	
	public int nodeSize()
	{
		return 1;
	}
	public long evaluate()
	{
		return value;
	}
	public boolean deepEquals(Expr expr)
	{
		return (expr instanceof ConstExpr && value == ((ConstExpr)expr).value);
	}
}
