package ctalz.cnstr;

import java.util.*;
import ctalz.util.*;

public class ConstProp extends Prop
{
	private boolean value;
	public static final ConstProp TRUE = new ConstProp(true), FALSE = new ConstProp(false);
	
	private ConstProp(boolean v)
	{
		value = v;
	}
	
	public boolean value()
	{
		return value;
	}
	
	protected Collection<VarExpr> collectFreeVariables(Collection<VarExpr> set)
	{
		return set;
	}
	
	public Prop substitute(Map<VarExpr, Expr> map)
	{
		return this;
	}
	
	protected void appendForUser(StringBuilder out, int outerOp)
	{
		out.append(value ? "true" : "false");
	}
	protected void appendForSolver(StringBuilder out)
	{
		out.append(value ? "TRUE" : "FALSE");
	}
	
	public Boolean evaluate()
	{
		return value;
	}
	public boolean deepEquals(Prop prop)
	{
		return (this == prop);
	}
}
