package ctalz.cnstr;

import java.util.*;
import ctalz.util.*;

public abstract class Expr
{
	public final Collection<VarExpr> freeVariables()
	{
		return collectFreeVariables(new LinkedHashSet<VarExpr>());
	}
	protected abstract Collection<VarExpr> collectFreeVariables(Collection<VarExpr> set);
	
	public abstract Expr substitute(Map<VarExpr, Expr> map);
	
	protected abstract void appendForUser(StringBuilder out, int outerPriority, boolean longFormat);
	protected abstract void appendForSolver(StringBuilder out);
	
	public abstract int nodeSize();
	public abstract long evaluate();
	protected static final long CANNOT_EVALUATE = Long.MAX_VALUE;
	public abstract boolean deepEquals(Expr expr);
	
	public final String toString()
	{
		StringBuilder result = new StringBuilder();
		appendForUser(result, 0, true);
		return result.toString();
	}
	public final String toShortString()
	{
		StringBuilder result = new StringBuilder();
		appendForUser(result, 0, false);
		return result.toString();
	}
}
