package ctalz.cnstr;

import java.util.*;
import ctalz.util.*;

public class VarExpr extends Expr
{
	private String name;
	private Map<Integer, VarExpr> multiples;
	private int id;
	private static boolean showID = (Config.asInt("ShowVariableID", 0) != 0);
	private static boolean sendName = (Config.asInt("SendVariableNameToSolver", 0) != 0);
	
	public VarExpr(String n)
	{
		name = n;
		id = Utilities.uniqueID();
	}
	public static VarExpr freshInstance()
	{
		return new VarExpr("<?>");
	}
	
	public VarExpr freshCopy()
	{
		return new VarExpr(name);
	}
	
	protected VarExpr multipleFor(int c)
	{
		if (multiples == null)
			multiples = new HashMap<Integer, VarExpr>(2);
		VarExpr result = multiples.get(c);
		if (result == null)
			multiples.put(c, result = new VarExpr(name + "_m" + c));
		return result;
	}
	
	protected Collection<VarExpr> collectFreeVariables(Collection<VarExpr> set)
	{
		set.add(this);
		return set;
	}
	
	public  Expr substitute(Map<VarExpr, Expr> map)
	{
		Expr e = map.get(this);
		return (e != null ? e : this);
	}
	
	public String name()
	{
		return userName();
	}
	protected String userName()
	{
		return name;
	}
	protected String solverName()
	{
		return (sendName ? name.replaceAll("[^a-zA-Z0-9_]", "_") + "_" + id : "v" + id);
	}
	
	protected void appendForUser(StringBuilder out, int outerPriority, boolean longFormat)
	{
		out.append(showID && longFormat ? userName() + "#" + id : userName());
	}
	protected void appendForSolver(StringBuilder out)
	{
		out.append(solverName());
	}
	
	public int nodeSize()
	{
		return 1;
	}
	public long evaluate()
	{
		return CANNOT_EVALUATE;
	}
	public boolean deepEquals(Expr expr)
	{
		return (this == expr);
	}
}
