package ctalz.comp.act;

import java.util.*;
import ctalz.util.*;

public class Asm extends ActNode
{
	private String mnemonic;
	private List<Object> operands;
	
	Asm(String m, Object... o)
	{
		mnemonic = m.intern(); operands = new ArrayList<Object>();
		Collections.addAll(operands, o);
	}
	
	void coercionConvert(Program prog, List<ActNode> nodes, StackLayout stack, RegFile regs)
	{
		assert false;
	}
	
	public String toString()
	{
		return "(asm " + mnemonic + " " + Utilities.enumerate(operands, " ") + ")";
	}
	String toAsmString()
	{
		List<String> tokens = new ArrayList<String>();
		tokens.add(mnemonic);
		for (Object o : operands) {
			if (o instanceof ActNode)
				tokens.add(((ActNode)o).toAsmString());
			else if (o != null)
				tokens.add(o.toString());
		}
		return toAsmString(tokens.toArray(new String[0]));
	}
}
