package ctalz.comp.act;

public class Const extends Operand
{
	public static final Const VOID = new Const(0), NULL_BP = new Const(0);
	
	final int val;
	
	public Const(int v)
	{
		val = v;
	}
	
	long extendedLongValue(boolean signExtend)
	{
		if (signExtend)
			return (long)val;
		else
			return ((long)val) & 0xFFFFFFFFL;
	}
	
	@Override public boolean equals(Object obj)
	{
		if (!(obj instanceof Const))
			return false;
		return (val == ((Const)obj).val);
	}
	@Override public int hashCode()
	{
		return val;
	}
	
	public String toString()
	{
		return "(const " + val + ")";
	}
	String toShortString()
	{
		return "C" + val;
	}
	String toAsmString()
	{
		return "$" + val;
	}
}
