package ctalz.comp.act;

import ctalz.comp.ctype.*;
import ctalz.util.*;

public class Reg extends Operand
{
	static final Reg[] instances = { new Reg(0, "%eax", ActNode.NO_EAX), new Reg(1, "%ebx", ActNode.NO_EBX), 
									 new Reg(2, "%ecx", ActNode.NO_ECX), new Reg(3, "%edx", ActNode.NO_EDX), 
									 new Reg(4, "%edi", ActNode.NO_EDI), new Reg(5, "%esi", 0) };
	static final Reg scratch = instances[5], sp = new Reg(-1, "%esp", -1);
	static final Reg userReturn = instances[0], baseReturn = instances[3];
	static final Reg[] calleeSaves = { instances[1], instances[4], instances[5] };
	
	final int index, noFlags;
	final String name;
	
	private Reg(int i, String n, int f)
	{
		index = i; name = n; noFlags = f;
	}
	
	static boolean isCalleeSave(int i)
	{
		for (Reg r : calleeSaves) {
			if (i == r.index)
				return true;
		}
		return false;
	}
	
	public String toString()
	{
		return name;
	}
	String toAsmString()
	{
		return name;
	}
}
