package ctalz.comp.act;

import java.util.*;
import ctalz.util.*;

class StackAccess extends ActNode
{
	private Op op;
	private StackLayout stack;
	private Var var;
	private Reg dest;
	private Triple<Integer, Integer, Integer> target;
	
	public enum Op
	{
		LD("sld"), ST("sst");
		
		private String mnemonic;
		Op(String m) { mnemonic = m; }
	}
	
	StackAccess(Op o, StackLayout s, Var v, Reg d)
	{
		op = o; stack = s.saveTypes(); var = v; dest = d;
	}
	
	void prologueConvert(Program prog, List<ActNode> nodes, StackLayout s)
	{
		target = stack.completeMissingTypes().locate(var);
		nodes.add(this);
	}
	
	public String toString()
	{
		Triple<Integer, Integer, Integer> i = (target != null ? target : stack.completeMissingTypes().locate(var));
		return "(" + op.mnemonic + "/" + i.fst + " " + dest + " " + i.snd + " " + i.thd + ")";
	}
	String toAsmString()
	{
		Triple<Integer, Integer, Integer> i = (target != null ? target : stack.completeMissingTypes().locate(var));
		return toAsmString(op.mnemonic + "<" + i.fst + "," + i.snd + ">", dest.toAsmString(), "$" + i.thd);
	}
}
