package ctalz.comp.act;

import ctalz.comp.*;
import ctalz.comp.ctype.*;
import ctalz.mac.*;
import ctalz.util.*;

public class Var extends ActNode
{
	ActType type;
	public final String name;
	final boolean isGlobal, isStatic, isVolatile;
	int indexForVarSet;
	
	public Var(ActType t, String n, boolean g, boolean s, boolean v)
	{
		type = t;
		name = (n == null ? "" : n);
		isGlobal = g;
		isStatic = s;
		isVolatile = v;
	}
	public Var(ActType t, String n)
	{
		this(t, n, false, false, false);
	}
	public Var(ActType t)
	{
		this(t, "");
	}
	public Var(CType t)
	{
		this(ActType.fromCType(t), "");
	}
	
	public String toString()
	{
		return ("(var" + (isGlobal ? "/g" : isVolatile ? "/v" : "") + " " + id + 
				(type == null ? "" : " " + type) + (name.equals("") ? "" : " \"" + name + "\"") + ")");
	}
	String toShortString()
	{
		return ("V" + (isGlobal ? "#" : isVolatile ? "!" : "") + id + (name.equals("") ? "" : "(" + name + ")"));
	}
	String toAsmString()
	{
		return (isGlobal ? Arch.encodeLabelName(name) + (isStatic ? Main.uniqueHash() : "") : super.toAsmString());
	}
}
