package ctalz.comp.act;

import java.util.*;

class VarSet
{
	private BitSet set;
	private Set<Var> registeredVars;
	
	VarSet()
	{
		registeredVars = new HashSet<Var>();
	}
	private VarSet(BitSet s)
	{
		set = s;
	}
	
	public VarSet copy()
	{
		return new VarSet(set == null ? new BitSet(registeredVars.size() + 5) : (BitSet)set.clone());
	}
	
	public void register(ActNode a)
	{
		if (a instanceof VarRef)
			a = ((VarRef)a).var;
		if (a instanceof Var && !registeredVars.contains(a)) {
			Var v = (Var)a;
			registeredVars.add(v);
			v.indexForVarSet = registeredVars.size();
		}
	}
	
	public void add(Var v)
	{
		set.set(v.indexForVarSet);
	}
	public void addAll(VarSet s)
	{
		set.or(s.set);
	}
	public void remove(Var v)
	{
		set.clear(v.indexForVarSet);
	}
	public void clear()
	{
		set.clear();
	}
	
	public int size()
	{
		return set.cardinality();
	}
	public boolean contains(ActNode v)
	{
		return (v instanceof Var && set.get(((Var)v).indexForVarSet));
	}
	public boolean sameAs(VarSet s)
	{
		return set.equals(s.set);
	}
	public boolean disjoint(VarSet s)
	{
		return !set.intersects(s.set);
	}
}
