package ctalz.comp.ast;

import java.io.*;
import java.util.*;
import ctalz.comp.act.*;
import ctalz.comp.ctype.*;
import ctalz.util.*;

public class DefStmt extends Stmt
{
	VarDef def;
	
	public DefStmt(VarDef d)
	{
		super(d.loc);
		def = d;
	}
	
	public DefStmt constructEnv(Env env)
	{
		def = def.constructEnv(env);
		return this;
	}
	
	public DefStmt transform(List<VarDef> prepend)
	{
		def = def.transform(prepend);
		return this;
	}
	
	public void compile(Program prog, Function init, Function fun)
	{
		def.compile(prog, init, fun);
	}
	
	public void writeTo(Writer out, int indent) throws IOException
	{
		out.append(Utilities.tab(indent)).append(def.toString());
	}
}
