package ctalz.comp.ast;

import java.util.*;
import ctalz.comp.act.*;
import ctalz.comp.ctype.*;

public class Entity
{
	Kind kind;
	String name;
	CType type;
	FunDef fun;
	int val;
	boolean isPointerTaken, transformDeref;
	Var userValue, baseValue;
	
	enum Kind
	{
		VAR, CONST, FUN, TYPE;
	}
	
	public Entity(Kind k, String n, CType t)
	{
		this(k, n, t, 0, null);
	}
	public Entity(FunDef f, String n, CType t)
	{
		this(Kind.FUN, n, t, 0, f);
	}
	private Entity(Kind k, String n, CType t, int v, FunDef f)
	{
		kind = k; name = n; type = t; val = v; fun = f;
	}
	public static Entity newConst(int val)
	{
		return new Entity(Kind.CONST, null, BasicType.INT, val, null);
	}
	
	public String toString()
	{
		switch (kind) {
		case VAR: return "Var " + name + " : " + type;
		case CONST: return "Const " + name + " : " + type + " = " + val;
		case FUN: return "Fun " + name + " : " + type;
		case TYPE: return "Type " + name + " : " + type;
		default: assert false; return "";
		}
	}
}
