package ctalz.comp.ast;

import java.io.*;
import java.util.*;
import ctalz.comp.act.*;
import ctalz.util.*;

public class ExprStmt extends Stmt
{
	private Expr expr;
	
	public ExprStmt(Expr e)
	{
		super(e.loc);
		expr = e;
	}
	public ExprStmt(Location l)
	{
		super(l);
	}
	
	public Stmt constructEnv(Env env)
	{
		if (expr != null)
			expr = expr.constructEnv(env);
		return this;
	}
	
	public Stmt transform(List<VarDef> prepend)
	{
		if (expr != null)
			expr = expr.transform(prepend);
		return this;
	}
	
	public void compile(Program prog, Function init, Function fun)
	{
		if (expr != null)
			expr.compile(prog, fun);
	}
	
	public void writeTo(Writer out, int indent) throws IOException
	{
		out.append(Utilities.tab(indent)).append(expr != null ? expr.toString() : "").append(";");
	}
}
