package ctalz.comp.ast;

import java.io.*;
import java.util.*;
import ctalz.comp.act.*;
import ctalz.util.*;

public class IndexExpr extends Expr
{
	private Expr lhs, rhs;
	
	public IndexExpr(Expr l, Expr r)
	{
		super(l.loc);
		lhs = l; rhs = r;
	}
	
	int priority()
	{
		return 900;
	}
	
	Expr constructEnv(Context ctx, boolean pointerTaken, Env env)
	{
		return new UnaryExpr(loc, UnaryExpr.Op.DEREF, 
							 new BinaryExpr(BinaryExpr.Op.ADD, lhs, rhs)).constructEnv(ctx, pointerTaken, env);
	}
	
	public Expr transform(List<VarDef> prepend)
	{
		assert false;
		return this;
	}
	
	public ConstValue eval()
	{
		assert false;
		return null;
	}
	
	ActValue compileAsRvalue(Program prog, Function fun)
	{
		assert false;
		return null;
	}
	
	public String toString()
	{
		String l = lhs.toString(), r = rhs.toString();
		if (lhs.priority() < priority())
			l = "(" + l + ")";
		return l + "[" + r + "]";
	}
}
