package ctalz.comp.ast;

import java.io.*;
import java.util.*;
import ctalz.comp.act.*;
import ctalz.comp.ctype.*;
import ctalz.util.*;

public abstract class Node
{
	public Location loc;
	
	public Node(Location l)
	{
		loc = l;
	}
	
	public abstract Node constructEnv(Env env);
	
	public abstract Node transform(List<VarDef> prepend);
	
	public abstract void compile(Program prog, Function initFun, Function currentFun);
	
	final Node setLoc(Location l)
	{
		loc = l;
		return this;
	}
	
	void reportUnsupportedFeature(String name)
	{
		reportUnsupportedFeature(loc, name);
	}
	void reportUnsupportedFeature(Location loc, String name)
	{
		ExceptionAccumulator.addFatal(loc, "unsupported", Utilities.localizedString(name));
	}
}
