package ctalz.comp.ast;

import java.io.*;
import java.util.*;
import ctalz.comp.act.*;
import ctalz.comp.ctype.*;
import ctalz.util.*;

public class ReturnStmt extends Stmt
{
	private Expr expr;
	private Entity retEntity;
	
	public ReturnStmt(Location l, Expr e)
	{
		super(l);
		expr = e;
	}
	
	public Stmt constructEnv(Env env)
	{
		retEntity = env.getEntity(loc, "$retVal");
		if (expr != null) {
			if (retEntity.type == BasicType.VOID)
				ExceptionAccumulator.add(expr.loc, "voidReturnVal");
			List<Stmt> stmts = new LinkedList<Stmt>();
			stmts.add(new ExprStmt(new AssignExpr(AssignExpr.Op.SIMPLE, new IdentExpr(expr.loc, "$retVal"), expr)));
			stmts.add(new JumpStmt(loc, JumpStmt.Op.GOTO, "$end"));
			return new CompoundStmt(loc, stmts).constructEnv(false, env);
		} else {
			if (retEntity.type != BasicType.VOID)
				ExceptionAccumulator.add(loc, "voidReturn");
			return new JumpStmt(loc, JumpStmt.Op.GOTO, "$end").constructEnv(env);
		}
	}
	
	public Stmt transform(List<VarDef> prepend)
	{
		assert false;
		return null;
	}
	
	public void compile(Program prog, Function init, Function fun)
	{
		assert false;
	}
	
	public void writeTo(Writer out, int indent) throws IOException
	{
		out.append(Utilities.tab(indent)).append("return");
		if (expr != null)
			out.append(" ").append(expr.toString());
		out.append(";");
	}
}
