package ctalz.comp.ast;

import java.util.*;
import ctalz.util.*;

public class ScSpec extends Spec
{
	final Kind kind;
	
	public enum Kind
	{
		AUTO, REGISTER, STATIC, EXTERN, TYPEDEF;
		
		public String toString() { return name().toLowerCase(); }
	}
	
	public ScSpec(Location l, Kind k)
	{
		super(l); kind = k;
	}
	
	static ScSpec find(Collection<? extends Spec> col, Kind k)
	{
		for (Spec s : col) {
			if (s instanceof ScSpec && ((ScSpec)s).kind == k)
				return (ScSpec)s;
		}
		return null;
	}
	
	public String toString()
	{
		return kind.toString();
	}
}
