package ctalz.comp.ast;

import java.util.*;
import ctalz.comp.ctype.*;
import ctalz.util.*;

public abstract class Spec
{
	final Location loc;
	
	public Spec(Location l)
	{
		loc = l;
	}
	
	public static CType constructCType(Env env, List<Spec> specs)
	{
		List<TypeSpec> ts = new ArrayList<TypeSpec>();
		boolean isConst = false, isVolatile = false;
		for (Spec s : specs) {
			if (s instanceof TypeSpec)
				ts.add((TypeSpec)s);
			else if (s instanceof TypeQual) {
				if (((TypeQual)s).kind == TypeQual.Kind.CONST)
					isConst = true;
				else
					isVolatile = true;
			}
		}
		CType t = TypeSpec.constructCType(env, ts);
		return (isConst ? t.constType() : t);
	}
	public static List<ScSpec> collectScSpecs(List<Spec> specs)
	{
		List<ScSpec> result = new ArrayList<ScSpec>();
		for (Spec s : specs) {
			if (s instanceof ScSpec)
				result.add((ScSpec)s);
		}
		return result;
	}
}
