package ctalz.comp.ast;

import java.util.*;
import ctalz.comp.ctype.*;
import ctalz.util.*;

public class SpecDecl extends VarDef
{
	public SpecDecl(List<Spec> s, Decl d)
	{
		super((s != null ? s : new ArrayList<Spec>()), new ArrayList<Decl>());
		if (specs.isEmpty())
			specs.add(new TypeSpec(Location.NULL, TypeSpec.Kind.INT));
		decls.add(d);
	}
	
	public Decl decl()
	{
		return decls.get(0);
	}
	
	public CType constructCType(Env env)
	{
		return decl().constructCType(env, Spec.constructCType(env, specs));
	}
	
	public String toString()
	{
		String d = decls.get(0).toString();
		return Utilities.enumerate(specs, " ") + (d.equals("") ? "" : " " + d);
	}
}
