package ctalz.comp.ast;

import java.io.*;
import java.util.*;
import ctalz.comp.act.*;
import ctalz.util.*;

public abstract class Stmt extends Node
{
	public Stmt(Location loc)
	{
		super(loc);
	}
	
	public abstract Stmt constructEnv(Env env);
	
	public abstract Stmt transform(List<VarDef> prepend);
	
	public final String toString()
	{
		return toString(0);
	}
	public final String toString(int indent)
	{
		try {
			StringWriter out = new StringWriter();
			writeTo(new PrintWriter(out), indent);
			return out.toString();
		} catch (IOException e) {
			return "";
		}
	}
	public abstract void writeTo(Writer out, int indent) throws IOException;
}
