package ctalz.comp.ctype;

import java.util.*;
import ctalz.comp.ast.*;
import ctalz.util.*;

public abstract class EnumType extends CType
{
	private EnumType()
	{
	}
	
	public static CType construct(Location loc, Env env, String name, List<VarDef> mems)
	{
		if (name != null && env.getEnumOrNull(name) == null)
			env.addEnum(loc, name, BasicType.INT);
		
		long prev = -1;
		for (VarDef d : mems) {
			for (Decl dc : d.decls) {
				if (dc.kind == Decl.Kind.ENUM) {
					dc.expr = dc.expr.constructEnv(env);
					ConstValue v = dc.expr.eval();
					if (v == null || !v.type.isIntegral())
						ExceptionAccumulator.add(dc.expr.loc, "shouldBeIntConst");
					else
						prev = (long)v.intValue - 1;
				}
				env.addEntity(dc.loc, dc.basemost().name, Entity.newConst((int)++prev));
			}
		}
		return BasicType.INT;
	}
}
