package ctalz.comp.ctype;

import ctalz.util.*;

public class PtrType extends CType
{
	public final CType base;
	
	public PtrType(CType b)
	{
		base = b;
	}
	
	public int sizeof()
	{
		return 4;
	}
	public int alignment()
	{
		return 4;
	}
	
	@Override public boolean equals(Object obj)
	{
		if (!(obj instanceof PtrType))
			return false;
		return base.equals(((PtrType)obj).base);
	}
	@Override public int hashCode()
	{
		return base.hashCode() * 101;
	}
	
	protected Pair<String, String> toString(boolean isConst)
	{
		Pair<String, String> b = base.toString(false);
		if (base instanceof ArrayType || base instanceof FunType) {
			b.fst += (isConst ? "(*const " : "(*");
			b.snd = ")" + b.snd;
		} else
			b.fst += (isConst ? "*const " : "*");
		return b;
	}
}
