package ctalz.mac;

import ctalz.util.*;

public class Arch
{
	public static final int wordSize = 4;
	private static OSType os;
	
	static {
		String osName = Config.asString("TargetOS", "auto");
		if (osName.equals("auto"))
			osName = System.getProperty("os.name");
		if (osName.toLowerCase().contains("mac"))
			os = OSType.MAC;
		else if (osName.toLowerCase().contains("linux"))
			os = OSType.LINUX;
		else
			os = OSType.GENERAL;
	}
	
	private Arch()
	{
	}
	
	public enum OSType
	{
		MAC, LINUX, GENERAL;
	}
	
	public static boolean isAccessibleMemorySize(int n)
	{
		return (n == 1 || n == 2 || n == 4);
	}
	public static String instructionSuffixForSize(int n)
	{
		return (n == 1 ? "b" : n == 2 ? "w" : n == 4 ? "l" : null);
	}
	
	public static OSType os()
	{
		return os;
	}
	public static String encodeLabelName(String name)
	{
		if (os == OSType.LINUX)
			return name;
		else
			return "_" + name;
	}
	
	public static int stackPointerAlignment()
	{
		return (os == OSType.MAC ? 16 : 1);
	}
}
