package ctalz.mac;

import java.util.*;

public class Register
{
	private static String[] idToName1 = { "%al",  "%bl",  "%cl",  "%dl",  "%edi", "%esi", "%esp" }, 
							idToName2 = { "%ax",  "%bx",  "%cx",  "%dx",  "%di",   "%si", "%esp" }, 
							idToName4 = { "%eax", "%ebx", "%ecx", "%edx", "%edi", "%esi", "%esp" };
	private static Map<String, Integer> nameToID = new HashMap<String, Integer>();
	public static final int numberOfGPRs, spID;
	
	static {
		int i = 0;
		for (String n : idToName4) {
			nameToID.put(n, i);
			i++;
		}
		numberOfGPRs = spID = i - 1;
	}
	
	private Register()
	{
	}
	
	public static int idForName(String name)
	{
		Integer i = nameToID.get(name);
		return (i == null ? -1 : i);
	}
	public static String nameForID(int id)
	{
		return idToName4[id];
	}
	public static String nameForID(int id, int size)
	{
		if (size == 1)
			return idToName1[id];
		else if (size == 2)
			return idToName2[id];
		else
			return idToName4[id];
	}
}
