package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.tc.checker.*;
import ctalz.type.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class CommitInst extends Inst
{
	private Operand reg;
	private VarExpr commitAs;
	
	public CommitInst(Location loc, Operand r, VarExpr a)
	{
		super(loc);
		reg = r; commitAs = a;
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		tc.checkReachability(loc);
		
		assertOperandKind(reg, Operand.Kind.REG);
		
		LinearType t = assertType(tc, reg, LinearType.class);
		IntType a = new IntType(commitAs);
		tc.state.heap.add(new Pair<Expr, BasicType>(commitAs, t.body()));
		reg.setType(tc, a);
		tc.state.solver.assume(new RelProp(RelProp.Op.NE, commitAs, ConstExpr.valueOf(0)));
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
	}
	
	public String toString()
	{
		return "commit " + reg + ", " + commitAs;
	}
}
