package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.tc.checker.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class DirectiveInst extends Inst
{
	private String directive;
	
	public DirectiveInst(Location l, String d)
	{
		super(l);
		directive = d;
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		if (!directive.trim().startsWith(".") || 
			directive.contains(";") || directive.contains("\n") || directive.contains("\r"))
			throw new TypeCheckException(loc, "invalidDirective");
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
		out.println(directive);
	}
	
	public String toString()
	{
		return ".directive " + Utilities.escape(directive);
	}
}
