package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.type.*;
import ctalz.tc.checker.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class EntryInst extends Inst
{
	private Operand label;
	
	public EntryInst(Location l, Operand a)
	{
		super(l);
		label = a;
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		assertOperandKind(label, Operand.Kind.LABEL);
		
		tc.initState();
		new ApplyInst(loc, new IndexOperand(loc, label.name()), 
					  ApplyInst.defaultTypes(loc), ApplyInst.defaultIndices(loc)).typecheck(tc, insts);
		new JmpInst(loc, JmpInst.Cond.ALWAYS, label).typecheck(tc, insts);
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
	}
	
	public String toString()
	{
		return ".entry " + label;
	}
}
