package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.tc.checker.*;
import ctalz.type.*;
import ctalz.cnstr.*;
import ctalz.mac.*;
import ctalz.util.*;

public class FallInst extends Inst
{
	public FallInst(Location loc)
	{
		super(loc);
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		tc.checkReachability(loc);
		
		if (!insts.hasNext())
			throw new TypeCheckException(loc, "missingLabelAfter");
		Inst next = insts.next();
		insts.previous();
		if (!(next instanceof LabelInst))
			throw new TypeCheckException(loc, "missingLabelAfter");
		new JmpInst(loc, JmpInst.Cond.ALWAYS, Operand.newLabel(loc, ((LabelInst)next).name())).typecheck(tc, insts);
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
	}
	
	public String toString()
	{
		return "fall";
	}
}
