package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.tc.*;
import ctalz.tc.checker.*;
import ctalz.type.*;
import ctalz.cnstr.*;
import ctalz.mac.*;
import ctalz.util.*;

public class HaltInst extends Inst
{
	private Operand exitCode;
	
	public HaltInst(Location loc, Operand e)
	{
		super(loc);
		exitCode = e;
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		tc.checkReachability(loc);
		
		assertOperandKind(exitCode, Operand.Kind.INT, Operand.Kind.REG);
		assertType(tc, exitCode, IntType.class);
		tc.state.solver.assume(ConstProp.FALSE);
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
		if (Arch.os() == Arch.OSType.MAC) {
			out.println("\tandl $~15, %esp");
			out.println("\tsubl $12, %esp");
		}
		out.println("\tpush " + exitCode.toString());
		out.println("\tcall " + Main.exitFunctionStubName());
	}
	
	public String toString()
	{
		return "halt " + exitCode;
	}
}
