package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.tc.checker.*;
import ctalz.type.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class LetInst extends Inst
{
	private VarExpr var;
	private IndexOperand value;
	private Operand reg;
	
	public LetInst(Location loc, VarExpr v, IndexOperand a)
	{
		super(loc);
		var = v; value = a;
	}
	public LetInst(Location loc, Operand r, VarExpr v)
	{
		super(loc);
		reg = r; var = v;
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		tc.checkReachability(loc);
		
		if (value != null)
			tc.state.solver.assume(new RelProp(RelProp.Op.EQ, var, value.index(tc)));
		else {
			assertOperandKind(reg, Operand.Kind.REG);
			// IntType t = assertType(tc, reg, IntType.class);
			// tc.state.solver.assume(new RelProp(RelProp.Op.EQ, var, t.value()));
			reg.setType(tc, new IntType(var));
		}
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
	}
	
	public String toString()
	{
		if (value != null)
			return "let " + var + ", " + value;
		else
			return "let " + reg + ", " + var;
	}
}
