package ctalz.tc.inst;

import java.util.*;
import ctalz.tc.checker.*;
import ctalz.type.*;
import ctalz.mac.*;
import ctalz.util.*;

public class TypeOperand extends Operand
{
	private Type type;
	private int regID;
	private String labelName;
	
	public TypeOperand(Location l, Type t)
	{
		super(l, Operand.Kind.META);
		type = t;
	}
	public TypeOperand(Location l, int r)
	{
		super(l, Operand.Kind.META);
		regID = r;
	}
	public TypeOperand(Location l, String n)
	{
		super(l, Operand.Kind.META);
		labelName = n;
	}
	
	@Override public Type type(TypeChecker tc) throws TypeCheckException
	{
		if (type != null)
			return type;
		else if (labelName != null)
			return tc.typeOfLabel(loc, labelName);
		else
			return tc.state.reg[regID];
	}
	public static List<Type> types(TypeChecker tc, List<TypeOperand> ops) throws TypeCheckException
	{
		List<Type> result = new ArrayList<Type>(ops.size());
		for (TypeOperand op : ops)
			result.add(op == null ? null : op.type(tc));
		return result;
	}
	
	public String toString()
	{
		if (type != null)
			return type.toString();
		else if (labelName != null)
			return "typeof(" + labelName + ")";
		else
			return "typeof(" + State.registerNameForID(regID) + ")";
	}
}
