package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.tc.checker.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class UnsafeInst extends Inst
{
	private String contents;
	private Prop precondition, postcondition;
	
	public UnsafeInst(Location l, String c, Prop r, Prop s)
	{
		super(l);
		contents = c; precondition = r; postcondition = s;
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		tc.checkReachability(loc);
		
		if (!tc.state.solver.isValid(precondition))
			throw new TypeCheckException(loc, "unsafePrecond");
		tc.state.solver.assume(postcondition);
		
		if (tc.warnUnsafe)
			ExceptionAccumulator.addWarning(loc, "unsafe");
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
		out.println(contents);
	}
	
	public String toString()
	{
		return ".unsafe_native " + Utilities.escape(contents) + ", [" + precondition + "], [" + postcondition + "]";
	}
}
