package ctalz.type;

import java.util.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class LinearType extends Type
{
	private TupleType body;
	
	public LinearType(TupleType t)
	{
		body = t;
	}
	
	public TupleType body()
	{
		return body;
	}
	
	public LinearType substitute(boolean copy, Map<TypeVar, Type> typeMap, Map<VarExpr, Expr> indexMap)
	{
		TupleType newBody = body.substitute(copy, typeMap, indexMap);
		return (newBody == body ? this : new LinearType(newBody));
	}
	public LinearType simplify(ConstraintSolver cs)
	{
		return new LinearType(body.simplify(cs));
	}
	
	protected boolean isEquivalent(Type target, 
								   ConstraintSolver cs, Map<TypeVar, Type> typeMap, Map<VarExpr, Expr> indexMap)
	{
		return (target instanceof LinearType && body.isEquivalent(((LinearType)target).body, cs, typeMap, indexMap));
	}
	
	public String typeForm()
	{
		return typeFormStatic();
	}
	public static String typeFormStatic()
	{
		return Utilities.localizedString("linearForm");
	}
	public String toString()
	{
		return "{" + body + "}";
	}
}
