package ctalz.util;

public class CTALException extends Exception
{
	protected Location loc;
	protected String message;
	private boolean isWarning, isFatal;
	
	public CTALException(Location l)
	{
		loc = (l == null ? Location.NULL : l);
		message = "";
	}
	public CTALException(Location l, String format, Object... args)
	{
		loc = (l == null ? Location.NULL : l);
		message = Utilities.localizedString(format, args);
	}
	
	public CTALException setWarning()
	{
		isWarning = true;
		return this;
	}
	public CTALException setFatal()
	{
		isFatal = true;
		return this;
	}
	
	public String message()
	{
		return message;
	}
	public Location loc()
	{
		return loc;
	}
	public boolean isWarning()
	{
		return isWarning;
	}
	public boolean isFatal()
	{
		return isFatal;
	}
}
