package ctalz.util;

import java.io.*;
import java.util.*;

public class Config
{
	private static ResourceBundle resource;
	static {
		try {
			resource = new PropertyResourceBundle(Thread.currentThread().getContextClassLoader()
													  .getResourceAsStream("config"));
		} catch (Exception e) {
		}
	}
	
	private Config()
	{
	}
	
	public static String asString(String key, String defaultValue)
	{
		try {
			return resource.getString(key);
		} catch (Exception e) {
			return defaultValue;
		}
	}
	public static int asInt(String key, int defaultValue)
	{
		try {
			return Integer.parseInt(resource.getString(key));
		} catch (Exception e) {
			return defaultValue;
		}
	}
}
