package ctalz.util;

public class Debug
{
	private static String messagePrefix = "", suppressMessagesClasses = "";
	static {
		messagePrefix = Config.asString("DebugMessagePrefix", "");
		suppressMessagesClasses = Config.asString("SuppressDebugMessages", "");
	}
	
	private Debug()
	{
	}
	
	public static void println(String clazz, Object obj)
	{
		if (suppressMessagesClasses.contains("-" + clazz))
			System.err.println(Utilities.indent(String.valueOf(obj), messagePrefix));
	}
	
	public static void println(Object obj)
	{
		println(Utilities.callerClass(), obj);
	}
	public static void fillLine(char chr)
	{
		int num = Progress.screenWidth() - messagePrefix.length() - 1;
		StringBuilder str = new StringBuilder();
		for (int i = 0; i < num; i++)
			str.append(chr);
		println(Utilities.callerClass(), str);
	}
}
